## Class Auth_OpenID_SessionNegotiator

Description

A session negotiator controls the allowed and preferred association types and association session types. Both the Auth_OpenID_Consumer and Auth_OpenID_Server use negotiators when creating associations.

You can create and use negotiators if you:

- Do not want to do Diffie-Hellman key exchange because you use

transport-layer encryption (e.g. SSL)

- Want to use only SHA-256 associations

- Do not want to support plain-text associations over a non-secure

channel

It is up to you to set a policy for what kinds of associations to accept. By default, the library will make any kind of association that is allowed in the OpenID 2.0 specification.

Use of negotiators in the library =================================

When a consumer makes an association request, it calls getAllowedType to get the preferred association type and association session type.

The server gets a request for a particular association/session type and calls isAllowed to determine if it should create an association. If it is supported, negotiation is complete. If it is not, the server calls getAllowedType to get an allowed association type to return to the consumer.

If the consumer gets an error response indicating that the requested association/session type is not supported by the server that contains an assocation/session type to try, it calls isAllowed to determine if it should try again with the given combination of association/session type.

Located in /Auth/OpenID/Association.php (line 527)

Method Summary
Auth_OpenID_SessionNegotiator Auth_OpenID_SessionNegotiator ( $allowed_types)
void getAllowedType ()
void isAllowed ( $assoc_type, $session_type)
Methods
Constructor Auth_OpenID_SessionNegotiator (line 528)
Auth_OpenID_SessionNegotiator Auth_OpenID_SessionNegotiator ( $allowed_types)

- $allowed_types

getAllowedType (line 603)

Get a pair of assocation type and session type that are supported.

void getAllowedType ()
isAllowed (line 588)
void isAllowed ( $assoc_type, $session_type)

- $assoc_type
- $session_type

Documentation generated on Tue, 21 Apr 2009 11:31:29 -0700 by phpDocumentor 1.3.2